org.apache.ignite.internal.util.future

## Class GridFinishedFuture<T>

- java.lang.Object
- - org.apache.ignite.internal.util.future.GridFinishedFuture<T>

All Implemented Interfaces:
  Externalizable, Serializable, IgniteInternalFuture<T>

Direct Known Subclasses:
  GridCacheQueryErrorFuture, GridDhtFinishedFuture

    public class GridFinishedFuture<T>
    extends Object
    implements IgniteInternalFuture<T>, Externalizable

Future that is completed at creation time.

See Also:
  Serialized Form

### Field Summary

Fields
`protected GridKernalContext` `ctx` Context.

### Constructor Summary

Constructors
Constructor and Description
`GridFinishedFuture()` Empty constructor required for `Externalizable`.
`GridFinishedFuture(GridKernalContext ctx)` Creates finished future with complete value.
`GridFinishedFuture(GridKernalContext ctx, T t)` Creates finished future with complete value.
`GridFinishedFuture(GridKernalContext ctx, Throwable err)`

### Method Summary

Methods
`boolean` `cancel()` Cancels this future.
`<R> IgniteInternalFuture<R>` `chain(IgniteClosure<? super IgniteInternalFuture<T>,R> doneCb)` Make a chained future to convert result of this future (when complete) into a new format.
`boolean` `concurrentNotify()` Gets value concurrent listener notification flag.
`void` `concurrentNotify(boolean concurNotify)` Flag to turn on or off concurrent listener notification.
`long` `duration()` Gets duration in milliseconds between start of the future and current time if future is not finished, or between start and finish of this future.
`T` `get()` Synchronously waits for completion of the computation and returns computation result.
`T` `get(long timeout)` Synchronously waits for completion of the computation for up to the timeout specified and returns computation result.
`T` `get(long timeout, TimeUnit unit)` Synchronously waits for completion of the computation for up to the timeout specified and returns computation result.
`boolean` `isCancelled()` Returns `true` if this computation was cancelled before it completed normally.
`boolean` `isDone()` Checks if computation is done.
`void` `listenAsync(IgniteInClosure<? super IgniteInternalFuture<T>> lsnr)` Registers listener closure to be asynchronously notified whenever future completes.
`void` `readExternal(ObjectInput in)`
`long` `startTime()` Gets start time for this future.
`void` `stopListenAsync(IgniteInClosure<? super IgniteInternalFuture<T>>... lsnr)` Removes given listeners from the future.
`boolean` `syncNotify()` Gets value of synchronous listener notification flag.
`void` `syncNotify(boolean syncNotify)` Flag to turn on or off synchronous listener notification.
`String` `toString()`
`void` `writeExternal(ObjectOutput out)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### ctx

    protected GridKernalContext ctx

Context.

### Constructor Detail

#### GridFinishedFuture

    public GridFinishedFuture()

Empty constructor required for `Externalizable`.

#### GridFinishedFuture

    public GridFinishedFuture(GridKernalContext ctx)

Creates finished future with complete value.

Parameters:
  `ctx` - Context.

#### GridFinishedFuture

    public GridFinishedFuture(GridKernalContext ctx,
                      T t)

Creates finished future with complete value.

Parameters:
  `ctx` - Context.
  `t` - Finished value.

#### GridFinishedFuture

    public GridFinishedFuture(GridKernalContext ctx,
                      Throwable err)

Parameters:
  `ctx` - Context.
  `err` - Future error.

### Method Detail

#### startTime

    public long startTime()

Gets start time for this future.

Specified by:
  `startTime` in interface `IgniteInternalFuture<T>`
Returns:
  Start time for this future.

#### duration

    public long duration()

Gets duration in milliseconds between start of the future and current time if future is not finished, or between start and finish of this future.

Specified by:
  `duration` in interface `IgniteInternalFuture<T>`
Returns:
  Time in milliseconds this future has taken to execute.

#### concurrentNotify

    public boolean concurrentNotify()

Gets value concurrent listener notification flag. This flag comes into play only when a future has more than one listener subscribed to it. If this flag is `true`, then all listeners will be notified concurrently by different threads; otherwise, listeners will be notified one after another within one thread (depending on `IgniteInternalFuture.syncNotify()` flag, these notifications may happen either in the same thread which started the future, or in a different thread).

Default value is `false`. To change the default, set `IgniteSystemProperties.IGNITE_FUT_CONCURRENT_NOTIFICATION` system property to `true`.

Specified by:
  `concurrentNotify` in interface `IgniteInternalFuture<T>`
Returns:
  Concurrent listener notification flag

#### concurrentNotify

    public void concurrentNotify(boolean concurNotify)

Flag to turn on or off concurrent listener notification. This flag comes into play only when a future has more than one listener subscribed to it. If this flag is `true`, then all listeners will be notified concurrently by different threads; otherwise, listeners will be notified one after another within one thread (depending on `IgniteInternalFuture.syncNotify()` flag, these notifications may happen either in the same thread which started the future, or in a different thread).

Default value is `false`. To change the default, set `IgniteSystemProperties.IGNITE_FUT_CONCURRENT_NOTIFICATION` system property to `true`.

Specified by:
  `concurrentNotify` in interface `IgniteInternalFuture<T>`
Parameters:
  `concurNotify` - Flag to turn on or off concurrent listener notification.

#### syncNotify

    public void syncNotify(boolean syncNotify)

Flag to turn on or off synchronous listener notification. If this flag is `true`, then upon future completion the notification may happen in the same thread that created the future. This becomes especially important when adding listener to a future that is already `done` - if this flag is `true`, then listener will be immediately notified within the same thread.

Default value is `false`. To change the default, set `IgniteSystemProperties.IGNITE_FUT_SYNC_NOTIFICATION` system property to `true`.

Specified by:
  `syncNotify` in interface `IgniteInternalFuture<T>`
Parameters:
  `syncNotify` - Flag to turn on or off synchronous listener notification.

#### syncNotify

    public boolean syncNotify()

Gets value of synchronous listener notification flag. If this flag is `true`, then upon future completion the notification may happen in the same thread that created the future. This becomes especially important when adding listener to a future that is already `done` - if this flag is `true`, then listener will be immediately notified within the same thread.

Default value is `false`. To change the default, set `IgniteSystemProperties.IGNITE_FUT_SYNC_NOTIFICATION` system property to `true`.

Specified by:
  `syncNotify` in interface `IgniteInternalFuture<T>`
Returns:
  Synchronous listener notification flag.

#### cancel

    public boolean cancel()

Cancels this future.

Specified by:
  `cancel` in interface `IgniteInternalFuture<T>`
Returns:
  `True` if future was canceled (i.e. was not finished prior to this call).

#### isCancelled

    public boolean isCancelled()

Returns `true` if this computation was cancelled before it completed normally.

Specified by:
  `isCancelled` in interface `IgniteInternalFuture<T>`
Returns:
  `True` if this computation was cancelled before it completed normally.

#### isDone

    public boolean isDone()

Checks if computation is done.

Specified by:
  `isDone` in interface `IgniteInternalFuture<T>`
Returns:
  `True` if computation is done, `false` otherwise.

#### get

    public T get()
          throws IgniteCheckedException

Synchronously waits for completion of the computation and returns computation result.

Specified by:
  `get` in interface `IgniteInternalFuture<T>`
Returns:
  Computation result.
Throws:
  `IgniteInterruptedCheckedException` - Subclass of `IgniteCheckedException` thrown if the wait was interrupted.
  `IgniteFutureCancelledCheckedException` - Subclass of `IgniteCheckedException` throws if computation was cancelled.
  `IgniteCheckedException` - If computation failed.

#### get

    public T get(long timeout)
          throws IgniteCheckedException

Synchronously waits for completion of the computation for up to the timeout specified and returns computation result. This method is equivalent to calling `get(long, TimeUnit.MILLISECONDS)`.

Specified by:
  `get` in interface `IgniteInternalFuture<T>`
Parameters:
  `timeout` - The maximum time to wait in milliseconds.
Returns:
  Computation result.
Throws:
  `IgniteInterruptedCheckedException` - Subclass of `IgniteCheckedException` thrown if the wait was interrupted.
  `IgniteFutureTimeoutCheckedException` - Subclass of `IgniteCheckedException` thrown if the wait was timed out.
  `IgniteFutureCancelledCheckedException` - Subclass of `IgniteCheckedException` throws if computation was cancelled.
  `IgniteCheckedException` - If computation failed.

#### get

    public T get(long timeout,
        TimeUnit unit)
          throws IgniteCheckedException

Synchronously waits for completion of the computation for up to the timeout specified and returns computation result.

Specified by:
  `get` in interface `IgniteInternalFuture<T>`
Parameters:
  `timeout` - The maximum time to wait.
  `unit` - The time unit of the `timeout` argument.
Returns:
  Computation result.
Throws:
  `IgniteInterruptedCheckedException` - Subclass of `IgniteCheckedException` thrown if the wait was interrupted.
  `IgniteFutureTimeoutCheckedException` - Subclass of `IgniteCheckedException` thrown if the wait was timed out.
  `IgniteFutureCancelledCheckedException` - Subclass of `IgniteCheckedException` throws if computation was cancelled.
  `IgniteCheckedException` - If computation failed.

#### listenAsync

    public void listenAsync(IgniteInClosure<? super IgniteInternalFuture<T>> lsnr)

Registers listener closure to be asynchronously notified whenever future completes.

Specified by:
  `listenAsync` in interface `IgniteInternalFuture<T>`
Parameters:
  `lsnr` - Listener closure to register. If not provided - this method is no-op.

#### stopListenAsync

    public void stopListenAsync(@Nullable
                       IgniteInClosure<? super IgniteInternalFuture<T>>... lsnr)

Removes given listeners from the future. If no listener is passed in, then all listeners will be removed.

Specified by:
  `stopListenAsync` in interface `IgniteInternalFuture<T>`
Parameters:
  `lsnr` - Listeners to remove.

#### chain

    public <R> IgniteInternalFuture<R> chain(IgniteClosure<? super IgniteInternalFuture<T>,R> doneCb)

Make a chained future to convert result of this future (when complete) into a new format. It is guaranteed that done callback will be called only ONCE.

Specified by:
  `chain` in interface `IgniteInternalFuture<T>`
Parameters:
  `doneCb` - Done callback that is applied to this future when it finishes to produce chained future result.
Returns:
  Chained future that finishes after this future completes and done callback is called.

#### writeExternal

    public void writeExternal(ObjectOutput out)
                       throws IOException

Specified by:
  `writeExternal` in interface `Externalizable`
Throws:
  `IOException`

#### readExternal

    public void readExternal(ObjectInput in)
                      throws IOException,
                             ClassNotFoundException

Specified by:
  `readExternal` in interface `Externalizable`
Throws:
  `IOException`
  `ClassNotFoundException`

#### toString

    public String toString()

Overrides:
  `toString` in class `Object`

2015 Copyright © Apache Software Foundation

Follow @ApacheIgnite

Ignite Fabric | : ver. 1.0.0-RC1
Release Date | : February 17 2015